From fe6e54e1c19bc76b4e4266a5177fae41e04c633f Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Fri, 1 Dec 2023 10:20:09 +0100
Subject: [PATCH 29/54] feat: view switcher bottom bar based navigation

---
 lact-gui/src/app/gpu_selector.rs   | 14 +++---
 lact-gui/src/app/mod.rs            | 74 +++---------------------------
 lact-gui/src/app/root_stack/mod.rs | 12 ++---
 3 files changed, 21 insertions(+), 79 deletions(-)

diff --git a/lact-gui/src/app/gpu_selector.rs b/lact-gui/src/app/gpu_selector.rs
index 4ef757bb..f1668b1d 100644
--- a/lact-gui/src/app/gpu_selector.rs
+++ b/lact-gui/src/app/gpu_selector.rs
@@ -11,12 +11,14 @@ pub struct GpuSelector {
 impl GpuSelector {
     pub fn new() -> Self {
         // WARN: gtk::ComboBoxText is deprecated, use gtk::DropDown instead
-        let dropdown = ComboBoxText::builder()
-            .margin_top(12)
-            .margin_bottom(12)
-            .margin_start(12)
-            .margin_end(12)
-            .build();
+        let dropdown = ComboBoxText::new();
+
+        dropdown
+            .first_child()
+            .unwrap()
+            .first_child()
+            .unwrap()
+            .add_css_class("flat");
 
         Self { dropdown }
     }
diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index 75c60a99..b45a252e 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -64,79 +64,19 @@ impl App {
 
         let root_view = libadwaita::ToolbarView::new();
 
-        let root_view_headerbar = libadwaita::HeaderBar::builder().show_title(true).build();
+        let root_view_headerbar = libadwaita::HeaderBar::builder().show_title(false).build();
         let apply_box = ApplyBox::new();
+        root_view_headerbar.pack_start(&gpu_selector.dropdown);
         root_view_headerbar.pack_end(&apply_box.container);
 
         root_view.add_top_bar(&root_view_headerbar);
-        root_view.set_content(Some(&root_stack.container));
-
-        let sidebar_view = libadwaita::ToolbarView::new();
-
-        let stack_sidebar = StackSidebar::builder()
+        root_view.add_bottom_bar(&libadwaita::ViewSwitcherBar::builder()
+            .reveal(true)
             .stack(&root_stack.container)
-            .vexpand(true)
-            .build();
-        stack_sidebar.remove_css_class("sidebar");
-        sidebar_view.add_top_bar(&libadwaita::HeaderBar::builder().show_title(true).build());
-        sidebar_view.set_content(Some(
-            &ScrolledWindow::builder()
-                .child(&stack_sidebar)
-                .vexpand(true)
-                .hscrollbar_policy(PolicyType::Never)
-                .build(),
-        ));
-        sidebar_view.add_bottom_bar(&gpu_selector.dropdown);
-
-        let root_nav_page = libadwaita::NavigationPage::builder()
-            .child(&root_view)
-            .title("Information")
-            .build();
-        let split_view = libadwaita::NavigationSplitView::builder()
-            .sidebar(
-                &libadwaita::NavigationPage::builder()
-                    .child(&sidebar_view)
-                    .title("LACT")
-                    .build(),
-            )
-            .content(&root_nav_page)
-            .build();
-
-        {
-            let split_view = split_view.clone();
-            let lb = stack_sidebar
-                .first_child()
-                .unwrap()
-                .first_child()
-                .unwrap()
-                .first_child()
-                .unwrap()
-                .downcast::<ListBox>()
-                .unwrap();
-            lb.connect_row_activated(move |_lb, _row| {
-                split_view.set_show_content(true);
-            });
-        }
-
-        {
-            let stack = root_stack.container.clone();
-            let root_nav_page = root_nav_page.clone();
-            root_stack.container.connect_visible_child_notify(move |_| {
-                if let Some(child) = stack.visible_child() {
-                    root_nav_page.set_title(stack.page(&child).title().unwrap().as_str())
-                }
-            });
-        }
-
-        let breakpoint = libadwaita::Breakpoint::new(libadwaita::BreakpointCondition::new_length(
-            libadwaita::BreakpointConditionLengthType::MaxWidth,
-            800.0,
-            libadwaita::LengthUnit::Sp,
-        ));
-        breakpoint.add_setter(&split_view, "collapsed", &glib::Value::from(true));
-        window.add_breakpoint(breakpoint);
+            .build());
+        root_view.set_content(Some(&root_stack.container));
 
-        window.set_content(Some(&split_view));
+        window.set_content(Some(&root_view));
 
         App {
             application,
diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index 0a18884a..06f7f147 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -13,7 +13,7 @@ use thermals_page::ThermalsPage;
 
 #[derive(Clone)]
 pub struct RootStack {
-    pub container: Stack,
+    pub container: libadwaita::ViewStack,
     pub info_page: InformationPage,
     pub thermals_page: ThermalsPage,
     pub oc_page: OcPage,
@@ -25,22 +25,22 @@ impl RootStack {
         system_info: SystemInfo,
         embedded_daemon: bool,
     ) -> Self {
-        let container = Stack::builder().vexpand(true).hexpand(true).build();
+        let container = libadwaita::ViewStack::builder().vexpand(true).hexpand(true).build();
 
         let info_page = InformationPage::new();
 
-        container.add_titled(&info_page.container, Some("info_page"), "Information");
+        container.add_titled_with_icon(&info_page.container, Some("info_page"), "Information", "info-symbolic");
 
         let oc_page = OcPage::new(&system_info);
 
-        container.add_titled(&oc_page.container, Some("oc_page"), "Overclock");
+        container.add_titled_with_icon(&oc_page.container, Some("oc_page"), "Overclock", "power-profile-performance-symbolic");
 
         let thermals_page = ThermalsPage::new(root_win);
 
-        container.add_titled(&thermals_page.container, Some("thermals_page"), "Thermals");
+        container.add_titled_with_icon(&thermals_page.container, Some("thermals_page"), "Thermals", "temperature-symbolic");
 
         let software_page = software_page(system_info, embedded_daemon);
-        container.add_titled(&software_page, Some("software_page"), "Software");
+        container.add_titled_with_icon(&software_page, Some("software_page"), "Software", "preferences-other-symbolic");
 
         Self {
             container,

